<?php
	function genera_entero( )
	{
		return mt_rand(100000, 300000);
	}

	function genera_cadena( )
	{
		$res = substr(md5(mt_rand( )), 0, mt_rand(4, 7));
		
		for ($i = 0; $i < strlen($res); ++$i) {
			if (ctype_digit($res[$i])) {
				$res[$i] = chr(ord($res[$i]) - ord('0') + ord('g'));
			}
		}
		
		return $res;
	}
	
	function genera_unicos($f, $n)
	{
		$arr = [ ];
		
		while (count($arr) < $n) {
			$arr[$f( )] = true;
		}
		
		return array_keys($arr);
	}
	
	function genera_cadenas_unicas($n)
	{
		return genera_unicos('genera_cadena', $n);
	}
	
	function genera_enteros_unicos($n)
	{
		return genera_unicos('genera_entero', $n);
	}
	
	function genera_carreras($n)
	{
		$nombres = genera_cadenas_unicas($n);
		$correos = genera_cadenas_unicas($n);
		$filas = [ ];

		for ($i = 0; $i < $n; ++$i) {
			$filas[] = "('{$nombres[$i]}', '{$correos[$i]}')";
		}
		
		echo "INSERT INTO carreras (nombre, correo) VALUES\n\t", implode(",\n\t", $filas), ";\n";
		return $nombres;
	}
	
	function genera_alumnos($n, $c)
	{
		$matriculas = genera_enteros_unicos($n);
		$filas = [ ];

		foreach ($matriculas as $matricula) {
			$nombre = genera_cadena( );
			$apellido = genera_cadena( );
			$carrera = mt_rand(1, $c);
			$estado = mt_rand(0, 2);
			$creditos = mt_rand(0, 60) * ($estado == 1);
			
			$filas[] = "($matricula, '$nombre', '$apellido', $carrera, $estado, $creditos)";
		}
		
		echo "INSERT INTO alumnos (matricula, nombre, apellido, carrera, estado, creditos) VALUES\n\t", implode(",\n\t", $filas), ";\n";
		return $matriculas;
	}
	
	function genera_telefonos($matriculas)
	{
		shuffle($matriculas);
		$filas = [ ];
		
		foreach ($matriculas as $matricula) {
			$cuantos = mt_rand(0, 2);
			
			for ($j = 0; $j < $cuantos; ++$j) {
				$telefono = genera_entero( );
				$filas[] = "($matricula, '$telefono')";
			}
		}
		
		echo "INSERT INTO telefonos (matricula, telefono) VALUES\n\t", implode(",\n\t", $filas), ";\n";
	}
	
	mt_srand(0);
	
	$c = 100;
	$n = 1000;
	
	ob_start( ); {
		readfile('universidad.sql');
		
		echo "\n\n";
		echo "USE ejemplo;\n";
		echo "SET FOREIGN_KEY_CHECKS = 0;\n";
		echo "\n";
		
		$carreras = genera_carreras($c);
		$matriculas = genera_alumnos($n, $c);
		genera_telefonos($matriculas);
		
		echo "\n";
		echo "SET FOREIGN_KEY_CHECKS = 1;\n";
	} file_put_contents('datos2.sql', ob_get_clean( ));
	
	echo "Hay $c carreras (de la 1 a la $c), algunas se llaman:\n\t{$carreras[22]}\n\t{$carreras[44]}\n\t{$carreras[66]}\n";
	echo "Hay $n alumnos, algunos son:\n\t{$matriculas[22]}\n\t{$matriculas[44]}\n\t{$matriculas[66]}\n";
?>